Package com.ads.api.util

# Class TagUtil

java.lang.Object
com.ads.api.util.BaseUtil
com.ads.api.util.TagUtil

public class TagUtil extends com.ads.api.util.BaseUtil
Contains the methods which performs the operations like creation, update, deletion and retrieval of tags.

RequestStatus as return type methods will result in being returned as either true or false as its status.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.ads.api.util.BaseUtil

  `com.ads.api.util.BaseUtil.TokenType`

- ## Field Summary

  ### Fields inherited from class com.ads.api.util.BaseUtil

  `AUTH_TOKEN, AUTH_TOKEN_TYPE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `RequestStatus`
  `addTag(Tag tag)`
  Inserts a new tag for the specified tag object.
  `String`
  `addTagAs(String tag, String outputFormat)`
  Inserts a new tag for the specified tag object.
  `RequestStatus`
  `addTags(List<Tag> tags)`
  Inserts list of tags for the specified list of tag objects.
  `String`
  `addTagsAs(String tags, String outputFormat)`
  Inserts list of tags for the specified list of tag objects.
  `RequestStatus`
  `associateTag(Node.NodeType nodeType, int nodeId, String tagName)`
  Tag is associated to the object for the specified nodeType and nodeId.
  `RequestStatus`
  `associateTag(Node.NodeType nodeType, List<Integer> nodeIds, String tagName)`
  The tag is associated to the objects for the specified nodeType and list of nodeIds.
  `String`
  `associateTagAs(String nodeType, int nodeId, String name, String outputFormat)`
  Tag is associated to the object for the specified nodeType and nodeId.
  `String`
  `associateTagByIdsAs(String nodeType, String nodeIds, String name, String outputFormat)`
  Tag is associated to the objects for the specified nodeType and list of nodeIds.
  `RequestStatus`
  `associateTags(Node.NodeType nodeType, int nodeId, List<String> tagNames)`
  List of tags are associated to the object for the specified nodeType and nodeId.
  `RequestStatus`
  `associateTags(Node.NodeType nodeType, List<Integer> nodeIds, List<String> tagNames)`
  List of tags are associated to the objects for the specified nodeType and list of nodeIds.
  `String`
  `associateTagsAs(String nodeType, int nodeId, String names, String outputFormat)`
  List of tags are associated to the object for the specified nodeType and nodeId.
  `String`
  `associateTagsByIdsAs(String nodeType, String nodeIds, String names, String outputFormat)`
  List of tags are associated to the objects for the specified nodeType and list of nodeIds.
  `RequestStatus`
  `clearTags(Node.NodeType nodeType, int nodeId)`
  Clears the tags for the specified nodeType and nodeId.
  `RequestStatus`
  `clearTags(Node.NodeType nodeType, List<Integer> nodeIds)`
  Clears the tags for the specified nodeType and list of nodeIds.
  `String`
  `clearTagsAs(String nodeType, int nodeId, String outputFormat)`
  Clears the tags for the specified nodeType and nodeId.
  `String`
  `clearTagsByIdsAs(String nodeType, String nodeIds, String outputFormat)`
  Clears the tags for the specified nodeType and list of nodeIds.
  `RequestStatus`
  `deleteTag(int tagId)`
  Removes tag object for the specified tag id.
  `RequestStatus`
  `deleteTag(Tag tag)`
  Removes tag for the specified tag object.
  `String`
  `deleteTagAs(int id, String outputFormat)`
  Removes tag object for the specified tag id.
  `String`
  `deleteTagAs(String tag, String outputFormat)`
  Removes tag for the specified tag object.
  `RequestStatus`
  `deleteTags(List<Integer> tagIds)`
  Removes tags for the specified list of tagIds.
  `String`
  `deleteTagsAs(String ids, String outputFormat)`
  Removes tags for the specified list of tagIds.
  `RequestStatus`
  `dissociateTag(Node.NodeType nodeType, int nodeId, String tagName)`
  The tag is dissociated from the object for the specified nodeType and nodeId.
  `RequestStatus`
  `dissociateTag(Node.NodeType nodeType, List<Integer> nodeIds, String tagName)`
  Tag is dissociated from the objects for the specified nodeType list of nodeIds and tagName.
  `String`
  `dissociateTagAs(String nodeType, int nodeId, String name, String outputFormat)`
  Tag is dissociated from the object for the specified nodeType and nodeId.
  `String`
  `dissociateTagByIdsAs(String nodeType, String nodeIds, String name, String outputFormat)`
  Tag is dissociated from the objects for the specified nodeType list of nodeIds and tagName.
  `RequestStatus`
  `dissociateTags(Node.NodeType nodeType, int nodeId, List<String> tagNames)`
  List of tags are dissociated from the object for the specified nodeType, nodeId and list of tagNames.
  `RequestStatus`
  `dissociateTags(Node.NodeType nodeType, List<Integer> nodeIds, List<String> tagNames)`
  List of tags are dissociated from the objects for the specified nodeType, list of nodeIds and list of tagNames.
  `String`
  `dissociateTagsAs(String nodeType, int nodeId, String names, String outputFormat)`
  List of tags are dissociated from the object for the specified nodeType, nodeId and list of tagNames.
  `String`
  `dissociateTagsByIdsAs(String nodeType, String nodeIds, String names, String outputFormat)`
  List of tags are dissociated from the objects for the specified nodeType, list of nodeIds and list of tagNames.
  `List<Tag>`
  `getAllTags()`
  Returns the list of all tags present in the master configuration.
  `String`
  `getAllTagsAs(String outputFormat)`
  Returns the list of all tags present in the master configuration.
  `List<Tag>`
  `getAssociatedTags(Node.NodeType nodeType, int nodeId)`
  Returns the list of associated tags of the specified nodeType and nodeId.
  `String`
  `getAssociatedTagsAs(String nodeType, int nodeId, String outputFormat)`
  Returns the list of associated tags of the specified nodeType and nodeId.
  `List<Association>`
  `getAssociations(String tagName, boolean fillInfo)`
  Returns the list of associations of the tag object for the specified.
  `String`
  `getAssociationsAs(String name, boolean fillInfo, String outputFormat)`
  Returns the list of associations of the tag object for the specified tag name.
  `List<Association>`
  `getAssociationsById(int tagId, boolean fillInfo)`
  Returns the list of associations of the tag object for the specified tagId.
  `String`
  `getAssociationsByIdAs(int id, boolean fillInfo, String outputFormat)`
  Returns the list of associations of the tag object for the specified tagId.
  `Tag`
  `getTag(int tagId)`
  Returns the tag object for the specified tag id.
  `Tag`
  `getTag(String tagName)`
  Returns the tag object for the specified tag name.
  `String`
  `getTagAs(int id, String outputFormat)`
  Returns the tag object for the specified tag id.
  `String`
  `getTagAs(String name, String outputFormat)`
  Returns the tag object for the specified tag name.
  `int`
  `getTagId(String tagName)`
  Returns the tag id for the specified tag name.
  `String`
  `getTagIdAs(String name, String outputFormat)`
  Returns the tag id for the specified tag name.
  `List<Tag>`
  `getTags(List<String> tagNames)`
  Returns the list of tag objects for the specified list of tag names.
  `String`
  `getTagsAs(String names, String outputFormat)`
  Returns the list of tag objects for the specified list of tag names.
  `List<Tag>`
  `getTagsByIds(List<Integer> tagIds)`
  Returns the list of tag objects for the specified list of tagIds.
  `String`
  `getTagsByIdsAs(String ids, String outputFormat)`
  Returns the list of tag objects for the specified list of tagIds.
  `RequestStatus`
  `publishTag(int tagId, boolean state)`
  The tag is published or unpublished for the specified tagId and state.
  `String`
  `publishTagAs(int id, boolean state, String outputFormat)`
  The tag is published or unpublished for the specified tagId and state.
  `RequestStatus`
  `publishTags(List<Integer> tagIds, boolean state)`
  The tags are published or unpublished for the specified list of tagIds and state.
  `String`
  `publishTagsAs(String ids, boolean state, String outputFormat)`
  The tags are published or unpublished for the specified list of tagIds and state.
  `RequestStatus`
  `updateTag(Tag tag)`
  Updates the tag for the specified tag object.
  `String`
  `updateTagAs(String tag, String outputFormat)`
  Updates the tag for the specified tag object.
  `RequestStatus`
  `updateTags(List<Tag> tags)`
  Updates the list of tags for the specified list of tag objects.
  `String`
  `updateTagsAs(String tags, String outputFormat)`
  Updates the list of tags for the specified list of tag objects.

  ### Methods inherited from class com.ads.api.util.BaseUtil

  `getAccessToken, getAccessTokenType, getTokenType, getUserDetails, permissionDeniedMessage, permissionDeniedStatus, setAccessToken, setAccessTokenType`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### addTag

    public RequestStatus addTag(Tag tag)
    Inserts a new tag for the specified tag object. The specified tag object should contain all the details pertaining to tag such as tag name, description, scopeObjectTypes etc.. where specification of tag name and scopeObjectTypes list is mandatory. The names of the objects in the scopeObjectTypes list should be the same as object names displayed in the master configuration of Enterprise tags.
    If tag is added successfully, requestStatus.isRequestSuccess() returns true otherwise it returns false.
    Parameters:
      `tag` - Tag
    Returns:
      RequestStatus object
    Since:
      12.1

  - ### addTags

    public RequestStatus addTags(List<Tag> tags) throws Exception
    Inserts list of tags for the specified list of tag objects. Each tag object should contain all the details pertaining to tag such as tag name, description, scopeObjectTypes etc.. where Specification of tag name and scopeObjectTypes list in each tag object is mandatory. The names of the objects in the scopeObjectTypes list should be the same as object names displayed in the master configuration of Enterprise tags.
    If tags are added successfully, requestStatus.isRequestSuccess() returns true otherwise it returns false.
    Parameters:
      `tags` - List
    Returns:
      RequestStatus object
    Throws:
      `Exception`
    Since:
      12.1

  - ### updateTag

    public RequestStatus updateTag(Tag tag)
    Updates the tag for the specified tag object. All the information pertaining to the tag can be updated. Specifying the tag id and tag name and scopeObjectTypes list are mandatory to update the tag. The names of the objects in the scopeObjectTypes list should be the same as object names displayed in the master configuration of Enterprise tags.
    If tag is updated successfully, requestStatus.isRequestSuccess() returns true otherwise it returns false.
    Parameters:
      `tag` - Tag
    Returns:
      RequestStatus object.
    Since:
      12.1

  - ### updateTags

    public RequestStatus updateTags(List<Tag> tags) throws com.icc.exceptions.DaoException
    Updates the list of tags for the specified list of tag objects. All the information pertaining to the tags can be updated. Specifying the tag id and tag name scopeObjectTypes list are mandatory in each tag object to update the tags. The names of the objects in the scopeObjectTypes list should be the same as object names displayed in the master configuration of Enterprise tags.
    If tags are updated successfully, requestStatus.isRequestSuccess() returns true otherwise it returns false.
    Parameters:
      `tags` - List
    Returns:
      RequestStatus object.
    Throws:
      `com.icc.exceptions.DaoException`
    Since:
      12.1

  - ### getTag

    public Tag getTag(String tagName) throws Exception
    Returns the tag object for the specified tag name. Specifying the tag name is mandatory.
    The returned tag object contains all the details of tag such as tag id name, description, scopeObjectTypes, auditHistory etc..
    Parameters:
      `tagName` - String
    Returns:
      Tag object
    Throws:
      `Exception`
    Since:
      12.1

  - ### getTag

    public Tag getTag(int tagId) throws Exception
    Returns the tag object for the specified tag id. Specifying the tag id is mandatory.
    The returned tag object contains all the details of tag such as tag name id, description, scopeObjectTypes, auditHistory etc..
    Parameters:
      `tagId` - int
    Returns:
      Tag object
    Throws:
      `Exception`
    Since:
      12.1

  - ### getTagsByIds

    public List<Tag> getTagsByIds(List<Integer> tagIds) throws Exception
    Returns the list of tag objects for the specified list of tagIds. Specifying the list of tagIds is mandatory.
    The returned tag objects contains all the details of tag such as tag name id, description, scopeObjectTypes, auditHistory etc..
    Parameters:
      `tagIds` - List
    Returns:
      List of tag objects
    Throws:
      `Exception`
    Since:
      12.1

  - ### getAllTags

    public List<Tag> getAllTags() throws Exception
    Returns the list of all tags present in the master configuration.
    The returned tag objects contains all the details of tag such as tag name id, description, scopeObjectTypes, auditHistory etc..
    Returns:
      List of tag objects
    Throws:
      `Exception`
    Since:
      12.1

  - ### getTagId

    public int getTagId(String tagName) throws Exception
    Returns the tag id for the specified tag name. Specifying the tag name is mandatory, based on the tag name, method will return the tagId.
    Parameters:
      `tagName` - String
    Returns:
      int
    Throws:
      `Exception`
    Since:
      12.1

  - ### deleteTag

    public RequestStatus deleteTag(int tagId)
    Removes tag object for the specified tag id. It deletes the tag only if it is not associated with any objects.
    If the tag is deleted all its associated data will also be deleted.
    If the tag is deleted successfully, RequestStatus.isRequestSuccess() will return true or it returns false.
    Parameters:
      `tagId` - int
    Returns:
      RequestStatus object.
    Since:
      12.1

  - ### deleteTag

    public RequestStatus deleteTag(Tag tag)
    Removes tag for the specified tag object. Specification of tag id is mandatory in the given tag object. It deletes the tag only if it is not associated with any objects.
    If the tag is deleted all its associated data will also be deleted.
    If the tag is deleted successfully, RequestStatus.isRequestSuccess() will return true or it returns false.
    Parameters:
      `tag` - Tag object.
    Returns:
      RequestStatus object.
    Since:
      12.1

  - ### deleteTags

    public RequestStatus deleteTags(List<Integer> tagIds)
    Removes tags for the specified list of tagIds. Specifying the list of tagIds is mandatory. Tags are deleted only if they are not associated with any objects.
    If the tags are deleted all its associated data will also be deleted.
    If the tags are deleted successfully, RequestStatus.isRequestSuccess() returns true otherwise returns false.
    Parameters:
      `tagIds` - List
    Returns:
      RequestStatus object.
    Since:
      12.1

  - ### publishTag

    public RequestStatus publishTag(int tagId, boolean state)
    The tag is published or unpublished for the specified tagId and state. Specifying the tag id and state is mandatory. If the value of state is true the tag is published, if it is false the tag is unpublished
    If tag is published or unpublished successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `tagId` - int
      `state` - boolean
    Returns:
      RequestStatus object.
    Since:
      12.1

  - ### publishTags

    public RequestStatus publishTags(List<Integer> tagIds, boolean state)
    The tags are published or unpublished for the specified list of tagIds and state. Specifying the tagIds list and state is mandatory. If the value of state is true the tags are published, if it is false the tags are unpublished
    If tags are published or unpublished successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `tagIds` - List
      `state` - boolean
    Returns:
      RequestStatus object.
    Since:
      12.1

  - ### associateTag

    public RequestStatus associateTag(Node.NodeType nodeType, int nodeId, String tagName) throws SQLException, IllegalArgumentException, com.ads.api.exceptions.RelationshipDetailNotFoundException
    Tag is associated to the object for the specified nodeType and nodeId. Specification of nodeType, nodeId and tagName is mandatory.
    If tag is associated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `nodeType` - Node.NodeType
      `nodeId` - int
      `tagName` - String
    Returns:
      RequestStatus object.
    Throws:
      `SQLException`
      `IllegalArgumentException`
      `com.ads.api.exceptions.RelationshipDetailNotFoundException`
    Since:
      12.1

  - ### associateTags

    public RequestStatus associateTags(Node.NodeType nodeType, int nodeId, List<String> tagNames) throws com.icc.exceptions.DaoException, Exception
    List of tags are associated to the object for the specified nodeType and nodeId. Specification of nodeType, nodeId and list of is tagNames mandatory.
    If tags are associated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `nodeType` - Node.NodeType
      `nodeId` - int
      `tagNames` - List
    Returns:
      RequestStatus object.
    Throws:
      `com.icc.exceptions.DaoException`
      `Exception`
    Since:
      12.1

  - ### associateTag

    public RequestStatus associateTag(Node.NodeType nodeType, List<Integer> nodeIds, String tagName)
    The tag is associated to the objects for the specified nodeType and list of nodeIds. Specification of nodeType, list of nodeIds and tagName is mandatory.
    If tag is associated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `nodeType` - Node.NodeType
      `nodeIds` - List
      `tagName` - String
    Returns:
      RequestStatus object.
    Since:
      12.1

  - ### associateTags

    public RequestStatus associateTags(Node.NodeType nodeType, List<Integer> nodeIds, List<String> tagNames) throws Exception
    List of tags are associated to the objects for the specified nodeType and list of nodeIds. Specification of nodeType, list of nodeIds and list of is tagNames mandatory.
    If tags are associated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `nodeType` - Node.NodeType
      `nodeIds` - List
      `tagNames` - List
    Returns:
      RequestStatus object.
    Throws:
      `Exception`
    Since:
      12.1

  - ### dissociateTag

    public RequestStatus dissociateTag(Node.NodeType nodeType, int nodeId, String tagName) throws Exception
    The tag is dissociated from the object for the specified nodeType and nodeId. Specification of nodeType, nodeId and tagName is mandatory.
    If tag is dissociated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `nodeType` - Node.NodeType
      `nodeId` - int
      `tagName` - String
    Returns:
      RequestStatus object.
    Throws:
      `Exception`
    Since:
      12.1

  - ### dissociateTags

    public RequestStatus dissociateTags(Node.NodeType nodeType, int nodeId, List<String> tagNames) throws Exception
    List of tags are dissociated from the object for the specified nodeType, nodeId and list of tagNames. Specification of nodeType, nodeId and list of tagNames is mandatory.
    If tags are dissociated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `nodeType` - Node.NodeType
      `nodeId` - int
      `tagNames` - List
    Returns:
      RequestStatus object.
    Throws:
      `Exception`
    Since:
      12.1

  - ### dissociateTag

    public RequestStatus dissociateTag(Node.NodeType nodeType, List<Integer> nodeIds, String tagName) throws Exception
    Tag is dissociated from the objects for the specified nodeType list of nodeIds and tagName. Specification of nodeType, list of nodeIds and tagName is mandatory.
    If tag is dissociated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `nodeType` - Node.NodeType
      `nodeIds` - List
      `tagName` - String
    Returns:
      RequestStatus object.
    Throws:
      `Exception`
    Since:
      12.1

  - ### dissociateTags

    public RequestStatus dissociateTags(Node.NodeType nodeType, List<Integer> nodeIds, List<String> tagNames) throws Exception
    List of tags are dissociated from the objects for the specified nodeType, list of nodeIds and list of tagNames. Specification of nodeType, list of nodeIds and list of tagNames is mandatory.
    If tags are dissociated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `nodeType` - Node.NodeType
      `nodeIds` - List
      `tagNames` - List
    Returns:
      RequestStatus object.
    Throws:
      `Exception`
    Since:
      12.1

  - ### clearTags

    public RequestStatus clearTags(Node.NodeType nodeType, int nodeId)
    Clears the tags for the specified nodeType and nodeId. Specifying the nodeType and nodeId are mandatory to clear the tags. i.e.,it removes all the tags associated from the object.
    If the tags are deleted all its associated data will also be deleted.
    If tags are cleared successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `nodeType` - Node.NodeType
      `nodeId` - int
    Returns:
      RequestStatus object.
    Since:
      12.1

  - ### clearTags

    public RequestStatus clearTags(Node.NodeType nodeType, List<Integer> nodeIds)
    Clears the tags for the specified nodeType and list of nodeIds. Specifying the nodeType and list of nodeIds are mandatory to clear the tags. i.e.,it removes all the tags associated from the objects.
    If the tags are cleared all its associated data will also be deleted.
    If tags are cleared successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `nodeType` - Node.NodeType
      `nodeIds` - List
    Returns:
      RequestStatus object.
    Since:
      12.1

  - ### getAssociationsById

    public List<Association> getAssociationsById(int tagId, boolean fillInfo) throws Exception
    Returns the list of associations of the tag object for the specified tagId. Specifying the tagId is mandatory.
    The returned associations list contains the information regarding each object that are associated with the given tagId.
    Parameters:
      `tagId` - int
      `fillInfo` - boolean
    Returns:
      List of associations
    Throws:
      `Exception`
    Since:
      12.1

  - ### getAssociations

    public List<Association> getAssociations(String tagName, boolean fillInfo) throws Exception
    Returns the list of associations of the tag object for the specified. tagName. Specifying the tagName is mandatory.
    The returned associations list contains the information regarding each object that are associated with the given tagName.
    Parameters:
      `tagName` - String
      `fillInfo` - boolean
    Returns:
      List of associations
    Throws:
      `Exception`
    Since:
      12.1

  - ### getAssociatedTags

    public List<Tag> getAssociatedTags(Node.NodeType nodeType, int nodeId) throws Exception
    Returns the list of associated tags of the specified nodeType and nodeId. Specifying the nodeType and nodeId are mandatory.
    Parameters:
      `nodeType` - Node.NodeType
      `nodeId` - int
    Returns:
      List of tags
    Throws:
      `Exception`
    Since:
      12.1

  - ### getTags

    public List<Tag> getTags(List<String> tagNames) throws Exception
    Returns the list of tag objects for the specified list of tag names. Specifying the list of tag names is mandatory.
    Each returned tag object contains all the details of tag such as tag id name, description, scopeObjectTypes etc..
    Parameters:
      `tagNames` - List
    Returns:
      List of tags
    Throws:
      `Exception`
    Since:
      12.1

  - ### addTagAs

    public String addTagAs(String tag, String outputFormat)
    Inserts a new tag for the specified tag object. The specified tag object should contain all the details pertaining to tag such as tag name, description, scopeObjectTypes etc.. Specification of tag name and scopeObjectTypes list is mandatory The names of the objects in the scopeObjectTypes list should be the same as object names displayed in the master configuration of Enterprise tags.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `tag` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tag is added successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Tag' JSON :
      {
      "name": "",
      "description": "",
      "published": true,
      "scopeObjectTypes": "",
      "auditHistory": null
      }
      }

    Since:
      12.1

  - ### addTagsAs

    public String addTagsAs(String tags, String outputFormat)
    Inserts list of tags for the specified list of tag objects. Each tag object should contain all the details pertaining to tag such as tag name, description, scopeObjectTypes etc.. where Specification of tag name and scopeObjectTypes list in each tag object is mandatory.
    The names of the objects in the scopeObjectTypes list should be the same as object names displayed in the master configuration of Enterprise tags.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `tags` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tags are updated successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String. [

      Sample 'Tags' JSON :
      {
      "name": "",
      "description": "",
      "published": true,
      "scopeObjectTypes": "",
      "auditHistory": null
      },
      {
      "name": "",
      "description": "",
      "published": true,
      "scopeObjectTypes": "",
      "auditHistory": null
      }
      ]

    Since:
      12.1

  - ### updateTagAs

    public String updateTagAs(String tag, String outputFormat)
    Updates the tag for the specified tag object. All the information pertaining to the tag can be updated. Specifying the tag id and tag name and scopeObjectTypes list are mandatory to update the tag. The names of the objects in the scopeObjectTypes list should be the same as object names displayed in the master configuration of Enterprise tags.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `tag` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tag is updated successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Tag' JSON :
      {
      "id": "",
      "name": "",
      "description": "",
      "published": true,
      "scopeObjectTypes": "",
      "auditHistory": null
      }

    Since:
      12.1

  - ### updateTagsAs

    public String updateTagsAs(String tags, String outputFormat)
    Updates the list of tags for the specified list of tag objects. All the information pertaining to the tags can be updated. Specifying the tag id and tag name scopeObjectTypes list are mandatory in each tag object to update the tags. The names of the objects in the scopeObjectTypes list should be the same as object names displayed in the master configuration of Enterprise tags..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `tags` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tags are updated successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'Tag' JSON : [
      {
      "id": "",
      "name": "",
      "description": "",
      "published": true,
      "scopeObjectTypes": "",
      "auditHistory": null
      },
      {
      "id": "",
      "name": "",
      "description": "",
      "published": true,
      "scopeObjectTypes": "",
      "auditHistory": null
      }
      ]

    Since:
      12.1

  - ### deleteTagAs

    public String deleteTagAs(String tag, String outputFormat)
    Removes tag for the specified tag object. Specification of tag id is mandatory in the given tag object. It deletes the tag only if it is not associated with any objects.
    If the tag is deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `tag` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tag is deleted successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.1

  - ### deleteTagAs

    public String deleteTagAs(int id, String outputFormat)
    Removes tag object for the specified tag id. It deletes the tag only if it is not associated with any objects.
    If the tag is deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `id` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tag is deleted successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.1

  - ### deleteTagsAs

    public String deleteTagsAs(String ids, String outputFormat)
    Removes tags for the specified list of tagIds. Specifying the list of tagIds is mandatory. Tags are deleted only if they are not associated with any objects.
    If the tags are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `ids` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tags are deleted successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.1

  - ### getTagAs

    public String getTagAs(String name, String outputFormat)
    Returns the tag object for the specified tag name. Specifying the tag name is mandatory.
    The returned tag object contains all the details of tag such as tag id name, description, scopeObjectTypes, auditHistory etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `name` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Tag object in the form of JSON or XML String.
    Since:
      12.1

  - ### getTagsAs

    public String getTagsAs(String names, String outputFormat)
    Returns the list of tag objects for the specified list of tag names. Specifying the list of tag names is mandatory.
    Each returned tag object contains all the details of tag such as tag id name, description, scopeObjectTypes, auditHistory etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `names` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Tag object in the form of JSON or XML String.
    Since:
      12.1

  - ### getTagAs

    public String getTagAs(int id, String outputFormat)
    Returns the tag object for the specified tag id. Specifying the tag id is mandatory.
    The returned tag object contains all the details of tag such as tag name id, description, scopeObjectTypes, auditHistory etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `id` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Tag object in the form of JSON or XML String.
    Since:
      12.1

  - ### getTagsByIdsAs

    public String getTagsByIdsAs(String ids, String outputFormat)
    Returns the list of tag objects for the specified list of tagIds. Specifying the list of tagIds is mandatory.
    The returned tag objects contains all the details of tag such as tag name id, description, scopeObjectTypes, auditHistory etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `ids` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      Tag objects in the form of JSON or XML String.
    Since:
      12.1

  - ### getAllTagsAs

    public String getAllTagsAs(String outputFormat)
    Returns the list of all tags present in the master configuration.
    The returned tag objects contains all the details of tag such as tag name id, description, scopeObjectTypes, auditHistory etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Tag objects in the form of JSON or XML String.
    Since:
      12.1

  - ### getTagIdAs

    public String getTagIdAs(String name, String outputFormat)
    Returns the tag id for the specified tag name. Specifying the tag name is mandatory, based on the tag name, method will return the tagId.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `name` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - TagId in the form of JSON or XML String.
    Since:
      12.1

  - ### publishTagAs

    public String publishTagAs(int id, boolean state, String outputFormat)
    The tag is published or unpublished for the specified tagId and state. Specifying the tag id and state is mandatory. If the value of state is true the tag is published, if it is false the tag is unpublished
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `id` - int
      `state` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tag is published or unpublished successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.1

  - ### publishTagsAs

    public String publishTagsAs(String ids, boolean state, String outputFormat)
    The tags are published or unpublished for the specified list of tagIds and state. Specifying the tagIds list and state is mandatory. If the value of state is true the tags are published, if it is false the tags are unpublished
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `ids` - String
      `state` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tags are published or unpublished successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.1

  - ### associateTagAs

    public String associateTagAs(String nodeType, int nodeId, String name, String outputFormat)
    Tag is associated to the object for the specified nodeType and nodeId. Specification of nodeType, nodeId and tagName is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeId` - int
      `name` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tag is associated successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.1

  - ### associateTagsAs

    public String associateTagsAs(String nodeType, int nodeId, String names, String outputFormat)
    List of tags are associated to the object for the specified nodeType and nodeId. Specification of nodeType, nodeId and list of is tagNames mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeId` - int
      `names` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tags are associated successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.1

  - ### associateTagByIdsAs

    public String associateTagByIdsAs(String nodeType, String nodeIds, String name, String outputFormat)
    Tag is associated to the objects for the specified nodeType and list of nodeIds. Specification of nodeType, list of nodeIds and tagName is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeIds` - String
      `name` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tag is associated successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.1

  - ### associateTagsByIdsAs

    public String associateTagsByIdsAs(String nodeType, String nodeIds, String names, String outputFormat)
    List of tags are associated to the objects for the specified nodeType and list of nodeIds. Specification of nodeType, list of nodeIds and list of is tagNames mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeIds` - String
      `names` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tags are associated successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.1

  - ### dissociateTagAs

    public String dissociateTagAs(String nodeType, int nodeId, String name, String outputFormat)
    Tag is dissociated from the object for the specified nodeType and nodeId. Specification of nodeType, nodeId and tagName is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeId` - int
      `name` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tag is dissociated successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.1

  - ### dissociateTagsAs

    public String dissociateTagsAs(String nodeType, int nodeId, String names, String outputFormat)
    List of tags are dissociated from the object for the specified nodeType, nodeId and list of tagNames. Specification of nodeType, nodeId and list of tagNames is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeId` - ing
      `names` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tags are dissociated successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.1

  - ### dissociateTagByIdsAs

    public String dissociateTagByIdsAs(String nodeType, String nodeIds, String name, String outputFormat)
    Tag is dissociated from the objects for the specified nodeType list of nodeIds and tagName. Specification of nodeType, list of nodeIds and tagName is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeIds` - String
      `name` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tag is dissociated successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.1

  - ### dissociateTagsByIdsAs

    public String dissociateTagsByIdsAs(String nodeType, String nodeIds, String names, String outputFormat)
    List of tags are dissociated from the objects for the specified nodeType, list of nodeIds and list of tagNames. Specification of nodeType, list of nodeIds and list of tagNames is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeIds` - String
      `names` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tags are dissociated successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.1

  - ### clearTagsAs

    public String clearTagsAs(String nodeType, int nodeId, String outputFormat)
    Clears the tags for the specified nodeType and nodeId. Specifying the nodeType and nodeId are mandatory to clear the tags. i.e.,it removes all the tags associated from the object.
    If the tags are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tags are cleared successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.1

  - ### clearTagsByIdsAs

    public String clearTagsByIdsAs(String nodeType, String nodeIds, String outputFormat)
    Clears the tags for the specified nodeType and list of nodeIds. Specifying the nodeType and list of nodeIds are mandatory to clear the tags. i.e.,it removes all the tags associated from the objects.
    If the tags are cleared all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeIds` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If tags are cleared successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.1

  - ### getAssociationsAs

    public String getAssociationsAs(String name, boolean fillInfo, String outputFormat)
    Returns the list of associations of the tag object for the specified tag name. Specifying the tag name and fillInfo are mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `name` - String
      `fillInfo` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String
    Since:
      12.1

  - ### getAssociationsByIdAs

    public String getAssociationsByIdAs(int id, boolean fillInfo, String outputFormat)
    Returns the list of associations of the tag object for the specified tagId. Specifying the tagId and fillInfo are mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `id` - int
      `fillInfo` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String
    Since:
      12.1

  - ### getAssociatedTagsAs

    public String getAssociatedTagsAs(String nodeType, int nodeId, String outputFormat)
    Returns the list of associated tags of the specified nodeType and nodeId. Specifying the nodeType and nodeId are mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String
    Since:
      12.1